#define MAIN 1
#define GETGC 1
#define PLACE_GRAPHICS 1
#define TOOSMALL 1
#define DOOPTIONS 1
#define READGRAPHICS 1
#define DRAWWILLIAMSIMAGES 0
#define EXITERROR 1
#define DRAWPIXEL 0

#define XK_LATIN1 1
#define XK_MISCELLANY 1

/*==========================================================
%COPYRIGHT
	Franklin Bowen (c) 1995
%RESTRICTED RIGHTS LEGEND
	You may use any part as long as I get some credit.
%SOURCE FILE
	willygraph.c
%DESCRIPTION OF FILE
	C source file.
%REVISED
	3Feb95 franklin -- Initial Version
%%
==========================================================*/


/*----------------------------
%Xlib INCLUDES
----------------------------*/
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/keysymdef.h>

/*----------------------------
%Standard C INCLUDES
----------------------------*/
#include <stdio.h>
#include <stdlib.h>

/*----------------------------
%Private INCLUDES
----------------------------*/

/*----------------------------
%Private #defines
----------------------------*/
#define TRUE	1
#define FALSE	0

#define PixelWidth	3
#define PixelHeight	4

/*----------------------------
%STATIC FUNCTIONS
----------------------------*/
static void ExitError();

/*----------------------------
%STATIC GLOBAL VARIABLES
----------------------------*/
static unsigned long filepos = 0;
static unsigned long ColorTableAddress = 0;
static unsigned long PixelsInGraphicLine = 32;
static unsigned long Rows = 10;
static unsigned long Height = 0;
static unsigned long Width = 0;

/* Space for error string */
char ErrorString[256];

/* Used as arguments to nearly every Xlib routine.  Making global simplifies */
Display	*display;
long	screen_num;

/* Name of invoking program.  Used in several places so global simplifies */
static char *progname;

/* RGB 2 & 3 bit -> 8 bit conversion values */
static unsigned short bits2Index[] = { 0x0000, 0x5555, 0xAAAA, 0xFFFF };
static unsigned short bits3Index[] =
	{ 0x0000, 0x2492, 0x4924, 0x6DB6, 0x9248, 0xB6DA, 0xDB6C, 0xFFFF };

/* Definition & declaration to hold graphic data */
typedef struct {
	unsigned long size;
	unsigned char *data;
} OurGraphicDataType;
OurGraphicDataType GraphicData;

typedef unsigned long COUNTER;


/*----------------------------
%EXTERNAL VARIABLES
----------------------------*/
extern int optind;
extern char *optarg;


/*----------------------------
%Global Williams info
----------------------------*/
#define MAX_COLORS	16
#define MIN(a, b) ((a) < (b) ? (a) : (b))

static XColor colors[MAX_COLORS];


Colormap OurXColorMap;


#define	WILLIAMSCOLORS	16

typedef struct {
	unsigned char	red:3;
	unsigned char	green:3;
	unsigned char	blue:2;
}	WillyColorType;

typedef struct {
	unsigned char	red;
	unsigned char	green;
	unsigned char	blue;
}	OurColorType;

typedef WillyColorType WillyColorTableType[WILLIAMSCOLORS];
WillyColorTableType WillyColorTable;

typedef struct {
	OurColorType	color[WILLIAMSCOLORS];
} OurColorTable_type;
OurColorTable_type OurColorTable;



/*==========================================================
%FUNCTION NAME
	main
%SCOPE
	private
%PURPOSE
	?
%SYNTAX INCLUDES
	#include "?"
%EXAMPLE CALL
	?ret_val = main(arg);
%RETURNS
	?
%METHOD
	?
%FILES
	?
%TABLES
	?
%SYNTAX ARGS
==========================================================*/
void main( argc, argv)

int	argc;		/* I	number of arguments (in argv)	*/
char	*argv[];	/* I	input arguments			*/
{
	void     DoOptions();
	void     ReadGraphics();
	void		HandleKeyAction();

	FILE		*FilePointer = NULL;	/* file pointer */

	Window		win;
	unsigned long	width;	/* Window Size */
	unsigned long	height;
	long		x = 0;	/* Window Position */
	long		y = 0;
	unsigned long	border_width = 4;	/* Border 4 pixels wide */
	unsigned long	display_width;
	unsigned long	display_height;

	char		*window_name = "Franklin's Basic Window Program";
	char		*icon_name = "FranklinIcon";
	XSizeHints	size_hints;	/* Preferred sizes for window man */

	XEvent		report;		/* Structure for event information */
	GC		gc;		/* ID of graphics context */
	char		*display_name = NULL;	/* Server to connect to */

	Screen		*screen_ptr;

	XWMHints	wm_hints;
	XClassHint	class_hints;
	XTextProperty	windowName;
	XTextProperty	iconName;

	Status			status;
	XWindowAttributes	windowattr;

/* Willy stuff */
	unsigned long plane_masks;
	unsigned long pixels[MAX_COLORS];
	unsigned long old_filepos = 0;
	unsigned long rows = 200;
	unsigned long columns = 32;

	KeySym keysym;
	int shift_lock = 0;
	int index = 0;

	COUNTER i;
	COUNTER scs;

	char HexString[8];
	unsigned char rgb;
#define RED 1
#define GREEN 2
#define BLUE 3
	unsigned int ColorValue;


	progname = argv[0];

	if (MAIN)
		printf( "Enter main\n");

	/*------------------------------------------------------
		Process options
	------------------------------------------------------*/
	DoOptions( argc, argv);

	if (PixelsInGraphicLine > 0)
		columns = PixelsInGraphicLine;
	if (Rows > 0)
		rows = Rows;
	old_filepos = filepos;

	/*------------------------------------------------------
		Open input file
	------------------------------------------------------*/
	if (argc > optind)
	{
		FilePointer = fopen( argv[optind], "rb");
		if (FilePointer == NULL)
		{
			strcpy( ErrorString, "Could not open input file ->");
			strcat( ErrorString, argv[optind]);
			ExitError();
		}
	}
	else
	{
		strcpy( ErrorString, "Must specify graphic file and color table address");
		ExitError();
	}


	/*------------------------------------------------------
		Read graphics file (whole executable?)
	------------------------------------------------------*/
	ReadGraphics( FilePointer, &GraphicData);

/*
	WillyColorTable = (WillyColorTableType *) &(GraphicData[ColorTableAddress]);
*/
	memcpy( &WillyColorTable, &(GraphicData.data[ColorTableAddress]),
		sizeof(WillyColorTable));


	/*------------------------------------------------------
		Connect to X server
	------------------------------------------------------*/
	display = XOpenDisplay( display_name);
	if (display == NULL)
	{
		fprintf( stderr, "%s: can not connect to X server [%s]\n",
			progname, XDisplayName( display_name));
		goto EXIT;
	}

	screen_num = DefaultScreen( display);
	screen_ptr = DefaultScreenOfDisplay( display);

	printf( "depth [%d]\n", DefaultDepth( display, screen_num));

	/*------------------------------------------------------
		Get display dimensions through window attributes
	------------------------------------------------------*/
	status = XGetWindowAttributes( display, RootWindow(
		display, screen_num), &windowattr);
	if (status == 0)
	{
		fprintf( stderr, "%s: failed to get window attributes.\n",
			progname);
		goto EXIT;
	}
	display_width = windowattr.width;
	display_height = windowattr.height;


	/*------------------------------------------------------
		Create window!
	------------------------------------------------------*/
	width = columns*PixelWidth;
	height = rows*PixelHeight;

	win = XCreateSimpleWindow( display, RootWindow( display, screen_num),
		x, y, width, height, border_width,
		BlackPixel( display, screen_num),
		WhitePixel( display, screen_num));
	if (win == 0)
	{
		fprintf( stderr, "%s: failed to create simple window.\n",
			progname);
		goto EXIT;
	}

	scs = width / ((columns+3)*PixelWidth);
	if (scs < 1)
		scs = 1;
	rows = height / PixelHeight;
	printf( "scs [%u], rows = [%u]\n", scs, rows);


	/*------------------------------------------------------
		Set window hints (x, y, width, and height
		hints are now (X11R4) taken from the actual
		window settings when it is mapped)
	------------------------------------------------------*/
	size_hints.flags = PPosition | PSize | PMinSize;
	size_hints.min_width = 1;
	size_hints.min_height = 1;

	status = XStringListToTextProperty( &window_name, 1, &windowName);
	if (status == 0)
	{
		fprintf( stderr, "%s: structure allocation for windowName failed.\n",
			progname);
		goto EXIT;
	}

	status = XStringListToTextProperty( &icon_name, 1, &iconName);
	if (status == 0)
	{
		fprintf( stderr, "%s: structure allocation for iconName failed.\n",
			progname);
		goto EXIT;
	}


	/*------------------------------------------------------
		Not iconified, expect keyboard input, set
		hint types
	------------------------------------------------------*/
	wm_hints.initial_state = NormalState;
	wm_hints.input = True;
	wm_hints.flags = StateHint | InputHint;

	class_hints.res_name = progname;
	class_hints.res_class = "XXXwin";


	/*------------------------------------------------------
		These are used by window manager to get info
		from the resource DB about this application
	------------------------------------------------------*/
	XSetWMProperties( display, win, &windowName, &iconName,
		argv, argc, &size_hints, &wm_hints, &class_hints);


	/*------------------------------------------------------
		Select event types we want to receive
	------------------------------------------------------*/
	XSelectInput( display, win, ExposureMask |
		KeyPressMask | KeyReleaseMask | ButtonPressMask | StructureNotifyMask);


	/*------------------------------------------------------
		Create GC for text and drawing
	------------------------------------------------------*/
	getGC( win, &gc);


	/*------------------------------------------------------
		Create our own color map
	------------------------------------------------------*/
	OurXColorMap = DefaultColormap( display, DefaultScreen( display));


	/*------------------------------------------------------
		Create our own color map
	------------------------------------------------------*/
	if (XAllocColorCells( display, OurXColorMap, False,
		&plane_masks, 0, pixels, MAX_COLORS) == 0)
	{
		strcpy( ErrorString, "Error in XAllocColorCells");
		ExitError();
	}


	/* initialize the pixel memory locations */
/*
*/
	for (i = 0; i < MAX_COLORS; i++)
	{
		colors[i].pixel = pixels[i];
		colors[i].flags = DoRed | DoGreen | DoBlue;
/*
		printf(
			"i[%lu], pixels[%d], red[%04X], green[%04X], blue[%04X]\n",
			i, pixels[i], WillyColorTable[i].red,
			WillyColorTable[i].green, WillyColorTable[i].blue);
*/
		colors[i].red = bits3Index[WillyColorTable[i].red];
		colors[i].green = bits3Index[WillyColorTable[i].green];
		colors[i].blue = bits2Index[WillyColorTable[i].blue];
/*
		printf( "[%04X%04X%04X] in RGB\n",
			colors[i].red, colors[i].green, colors[i].blue);
*/
	}

	
	status = XStoreColors(display, OurXColorMap, colors, MAX_COLORS);
	printf( "XStoreColors returned status [%d]\n", status);


	/*------------------------------------------------------
		Display window
	------------------------------------------------------*/
	XSetBackground( display, gc, colors[0].pixel);
	XSetWindowBackground( display, win, colors[0].pixel);


	XMapWindow( display, win);


	/*------------------------------------------------------
		Event loop
	------------------------------------------------------*/
	while (1)
	{
		XNextEvent( display, &report);

		switch (report.type)
		{
			case Expose:

				/*------------------------------
					Only draw on last expose
					if window big enough
				------------------------------*/
				if (report.xexpose.count == 0)
				{
					printf( "Expose serial # [%u] count [%d]\n",
						report.xexpose.serial,
						report.xexpose.count);

					filepos = old_filepos;
					DrawWilliamsImages(
						win, gc, GraphicData, &filepos, rows, columns, scs);
					printf( "old_filepos [%04X], filepos [%04X]\n",
						old_filepos, filepos);
				}

				break;

			case ConfigureNotify:
				width = report.xconfigure.width;
				height = report.xconfigure.height;
				scs = width / ((columns+3)*PixelWidth);
				if (scs < 1)
					scs = 1;
				rows = height / PixelHeight;
				printf( "scs [%u], rows = [%u]\n", scs, rows);

				filepos = old_filepos;
				DrawWilliamsImages(
					win, gc, GraphicData, &filepos, rows, columns, scs);
				printf( "old_filepos [%04X], filepos [%04X]\n",
					old_filepos, filepos);

				break;
			
			case ButtonPress:
				XFreeGC( display, gc);
				XCloseDisplay( display);
				goto EXIT;

			case KeyRelease:

				HandleKeyAction( display, report.xkey.keycode, index, &keysym);

				switch (keysym)
				{
					case XK_Shift_Lock:
					case XK_Caps_Lock:

						index = 0;
						shift_lock = FALSE;
						break;

					case XK_Shift_L:
					case XK_Shift_R:

						if (shift_lock != TRUE)
							index = 0;
						break;

					default:
						break;
				}

				break;

			case KeyPress:

				HandleKeyAction( display, report.xkey.keycode, index, &keysym);

				switch (keysym)
				{
					case XK_Shift_Lock:
					case XK_Caps_Lock:

						index = 1;
						shift_lock = TRUE;
						break;

					case XK_Shift_L:
					case XK_Shift_R:

						index = 1;
						break;

					case XK_underscore:
					case XK_minus:

						filepos = old_filepos;
						if (filepos > 0);
							filepos--;
						break;

					case XK_plus:
					case XK_equal:

						filepos = old_filepos;
						if (filepos < 65535);
							filepos++;
						break;

					case XK_bracketleft:

						filepos = old_filepos;
						if (filepos >= (columns/2));
							filepos = filepos-(columns/2);
						break;

					case XK_bracketright:

						filepos = old_filepos;
						if (filepos <= (65535-(columns/2)));
							filepos = filepos+(columns/2);
						break;

					case XK_a:

						filepos = old_filepos;
						columns = columns - 2;
						if (columns < 2)
							columns = 2;
						scs = width / ((columns+3)*PixelWidth);
						if (scs < 1)
							scs = 1;
						printf( "columns [%lu]\n", columns);
						break;

					case XK_s:

						filepos = old_filepos;
						if (((columns+3)*PixelWidth) <= width)
							columns = columns + 2;
						scs = width / ((columns+3)*PixelWidth);
						if (scs < 1)
							scs = 1;
						printf( "columns [%lu]\n", columns);
						break;

					case XK_c:

						filepos = old_filepos;
						do
							XNextEvent( display, &report);
						while (report.type != KeyPress);
						HandleKeyAction(display, report.xkey.keycode, index, &keysym);
						if (isxdigit( keysym))
						{
							HexString[0] = keysym;
							HexString[1] = '\0';
							sscanf( HexString, "%X", &i);
						}
						else
							break;

						do
							XNextEvent( display, &report);
						while (report.type != KeyPress);
						HandleKeyAction(display, report.xkey.keycode, index, &keysym);
						if (keysym == XK_r)
							rgb = RED;
						else if (keysym == XK_g)
							rgb = GREEN;
						else if (keysym == XK_b)
							rgb = BLUE;
						else
							break;

						do
							XNextEvent( display, &report);
						while (report.type != KeyPress);
						HandleKeyAction(display, report.xkey.keycode, index, &keysym);
						if (isxdigit( keysym))
						{
							HexString[0] = keysym;
						}
						else
							break;

						do
							XNextEvent( display, &report);
						while (report.type != KeyPress);
						HandleKeyAction(display, report.xkey.keycode, index, &keysym);
						if (isxdigit( keysym))
						{
							HexString[1] = keysym;
							HexString[2] = '\0';
							sscanf( HexString, "%X", &ColorValue);
							ColorValue = ColorValue * 257;
						}
						else
							break;

						if (rgb == RED)
							colors[i].red = (unsigned short) ColorValue;
						else if (rgb == GREEN)
							colors[i].green = (unsigned short) ColorValue;
						else if (rgb == BLUE)
							colors[i].blue = (unsigned short) ColorValue;
						printf( "[%04X%04X%04X] in RGB\n",
							colors[i].red, colors[i].green, colors[i].blue);

						status = XStoreColors(display, OurXColorMap, colors, MAX_COLORS);
						printf( "XStoreColors returned status [%d]\n", status);

						if (i == 0)
						{
							XSetBackground( display, gc, colors[0].pixel);
							XSetWindowBackground( display, win, colors[0].pixel);
						}

						break;

					default:
						break;
				}

				old_filepos = filepos;
				DrawWilliamsImages(
					win, gc, GraphicData, &filepos, rows, columns, scs);
				printf( "old_filepos [%04X], filepos [%04X]\n",
					old_filepos, filepos);

				break;

			default:
				break;
		}
	}

EXIT:
	if (MAIN)
		printf( "Exit main\n");
}


getGC( win, gc)

Window		win;
GC		*gc;
{
	unsigned long	valuemask = 0;

	XGCValues	values;

	unsigned long	line_width = 4;
	long		line_style = LineDoubleDash;
	long		cap_style = CapProjecting;
	long		join_style = JoinMiter;
	long		dash_offset = 0;

	static char	dash_list[] = { 12, 24};
	long		list_length = 2;


	if (GETGC)
		printf( "Enter getGC\n");

	/* Create default Graphics Context */
	*gc = XCreateGC( display, win, valuemask, &values);

	/*specify black foreground */
	XSetForeground( display, *gc, WhitePixel( display, screen_num));

	/* Set line attributes */
	XSetLineAttributes( display, *gc, line_width,
		line_style, cap_style, join_style);

	/* Set dashes */
	XSetDashes( display, *gc, dash_offset, dash_list, list_length);

	if (GETGC)
		printf( "Exit getGC\n");
}


/*==============================================================================
Start Willy color stuff
==============================================================================*/
void DoOptions( argc, argv)
long  argc;
char **argv;
{
	long Option;


	if (DOOPTIONS)
		printf( "Enter DoOptions\n");

	while ((Option = getopt( argc, argv, "f:c:b:r:h:w:")) != EOF)
	{
		switch (Option)
		{
			case 'f':	/* (hex) address of graphic data */
				sscanf( optarg, "%x", &filepos);
				break;
			case 'c':	/* (hex) address of color table */
				sscanf( optarg, "%x", &ColorTableAddress);
				break;
			case 'b':	/* pixels in a graphic line (must be even!) */
				PixelsInGraphicLine = atoi( optarg);
				break;
			case 'r':	/* rows */
				Rows = atoi( optarg);
				break;
			case 'h':	/* height */
				Height = atoi( optarg);
				break;
			case 'w':	/* width */
				Width = atoi( optarg);
				break;
		}
	}

	if (DOOPTIONS)
		printf( "Exit DoOptions\n");
}


void ReadGraphics( FilePointer, GraphicData)

FILE               *FilePointer;
OurGraphicDataType *GraphicData;
{
	long BytesInFile = 0;
	long BytesRead = 0;


	if (READGRAPHICS)
		printf( "Enter ReadGraphics\n");

	/*------------------------------------------------------
		Position to end of file
	------------------------------------------------------*/
	if (fseek( FilePointer, 0, SEEK_END) == -1)
	{
		strcpy( ErrorString, "Error while trying to seek to EOF");
		ExitError();
	}


	/*------------------------------------------------------
		Get position (thus bytes in file!)
	------------------------------------------------------*/
	BytesInFile = ftell( FilePointer);


	/*------------------------------------------------------
		Allocate memory and set up graphic data structure
	------------------------------------------------------*/
	GraphicData->size = BytesInFile;
	GraphicData->data = calloc( BytesInFile, sizeof( unsigned char));
	if (GraphicData->data == NULL)
	{
		sprintf( ErrorString, "Could not allocate [%d] bytes for graphic data",
			BytesInFile);
		ExitError();
	}


	/*------------------------------------------------------
		Position to beginning of file
	------------------------------------------------------*/
	if (fseek( FilePointer, 0, SEEK_SET) == -1)
	{
		strcpy( ErrorString, "Error while trying to seek to BOF");
		ExitError();
	}



	/*------------------------------------------------------
		Read graphic data
	------------------------------------------------------*/
	BytesRead = fread( GraphicData->data, sizeof( unsigned char),
		GraphicData->size, FilePointer);

	if (BytesRead != GraphicData->size)
	{
		if (READGRAPHICS)
			fprintf( stderr, "GraphicData->size [%d], BytesRead [%d]\n",
				GraphicData->size, BytesRead);

		strcpy( ErrorString, "Error while trying to read the graphic data");
		ExitError();
	}

	if (READGRAPHICS)
		printf( "Exit ReadGraphics\n");
}


DrawWilliamsImages( win, gc, GraphicData, filepos, rows, columns, scs)

Window             win;
GC                 gc;
OurGraphicDataType GraphicData;
long               *filepos;
unsigned long      rows;
unsigned long      columns;
COUNTER            scs;
{
	void DrawPixel();

	typedef struct {
		unsigned char LowNibble:4;
		unsigned char HighNibble:4;
	} GraphicByteType;
	GraphicByteType *GraphicByte;

	COUNTER row;
	COUNTER column;
	COUNTER sc;

	static COUNTER old_columns = 0;


	if (DRAWWILLIAMSIMAGES)
		printf( "Enter DrawWilliamsImages\n");


	if ((old_columns != columns) && (old_columns != 0))
		XClearWindow( display, win);
	old_columns = columns;


	/*------------------------------------------------------
		Set graphic byte structure to look into graphic data
	------------------------------------------------------*/
	GraphicByte = (GraphicByteType *) &(GraphicData.data[*filepos]);


	/*------------------------------------------------------
		For super column...
	------------------------------------------------------*/
	for (sc = 0; sc < scs; sc++)
	{


	/*------------------------------------------------------
		For number of rows...
	------------------------------------------------------*/
	for (row = 0; row < rows; row++)
	{

		/*----------------------------------------------
			For columns/2 (2 pixels per byte)
		----------------------------------------------*/
		for (column = 0; column < columns; column++)
		{

			/*--------------------------------------
				Read byte and split into nibbles
			--------------------------------------*/
			if (DRAWWILLIAMSIMAGES)
				printf( "filepos [%lu], GraphicByte [%02X], HighNibble [%02X], LowNibble [%02X]\n", *filepos, *GraphicByte, GraphicByte->HighNibble, GraphicByte->LowNibble);


			/*--------------------------------------
				Get color number highNibble
				Draw filled rectangle
				Get color number lowNibble
				Draw filled rectangle
			--------------------------------------*/
			DrawPixel(win,gc,(unsigned char) GraphicByte->HighNibble, row, column++, columns, sc);
			DrawPixel(win,gc,(unsigned char) GraphicByte->LowNibble, row, column, columns, sc);
			(*filepos)++;
			GraphicByte++;
		}


		/*----------------------------------------------
			Move drawing location down one and back
			columns
		----------------------------------------------*/

	}

	} /* super column */

	if (DRAWWILLIAMSIMAGES)
		printf( "Exit DrawWilliamsImages\n");
}


void ExitError( String)

char *String;
{
	if (EXITERROR)
		printf( "Enter ExitError\n");

	fprintf( stderr, "%s: %s\n", "WilliamsGraphics", String);

	if (EXITERROR)
		printf( "Enter ExitError\n");

	exit( -1);
}


void DrawPixel( win, gc, pixel, row, column, columns, sc)

Window          win;
GC              gc;
unsigned char   pixel;
COUNTER         row;
COUNTER         column;
unsigned long   columns;
COUNTER         sc;
{

	if (DRAWPIXEL)
	{
		printf( "Enter DrawPixel\n");
		printf( "pixel [%d], row [%d], column[%d], columns [%d], sc [%d]\n",
			pixel, row, column, columns, sc);
	}

	
	/*------------------------------------------------------
		Set foreground color
	------------------------------------------------------*/
	XSetForeground( display, gc, colors[pixel].pixel);


	/*------------------------------------------------------
		Draw pixel
	------------------------------------------------------*/
	XFillRectangle( display, win, gc, PixelWidth*(column+(sc*(columns+3))),
		PixelHeight*row, PixelWidth, PixelHeight);


	if (DRAWPIXEL)
		printf( "Exit DrawPixel\n");
}


void HandleKeyAction( display, keycode, index, keysym)

Display *display;
KeyCode keycode;
int index;
KeySym *keysym;
{
	*keysym = XKeycodeToKeysym( display, keycode, index);
	printf( "keycode [%X] is keysym [%X]", keycode, *keysym);
	if ((*keysym < 0xFF) && isprint( (int) *keysym))
		printf( " is ASCII [%c]\n", *keysym);
	else
		printf( "\n");
}
